﻿using System;
using System.IO;
using System.Text;
using JetBrains.Annotations;

namespace Sda.DictionaryItemEnumGenerator
{
    public static class Utils
    {

        #region Utils
        /// <summary>
        /// Angolosítja a magyar ékezetes betűket.
        /// Ez az összehasonlításnál kell, angol karakterláncokat nagyobb
        /// biztonsággal lehet összehasonlítani, plusz az ékezetes betűket megeszi a VSS
        /// ezért a kódban ilyet írni plusz összehasonlítani hibaforrás!
        /// </summary>
        [NotNull]
        public static string ToBase26String([CanBeNull] this string str)
        {
            if (str == null)
                return "";
            str = str
                .Replace('É', 'E').Replace('Á', 'A').Replace('Ű', 'U')
                .Replace('Ö', 'O').Replace('Ü', 'U').Replace('Ó', 'O')
                .Replace('Ő', 'O').Replace('Ú', 'U').Replace('Í', 'I')
                .Replace('é', 'e').Replace('á', 'a').Replace('ű', 'u')
                .Replace('ö', 'o').Replace('ü', 'u').Replace('ó', 'o')
                .Replace('ő', 'o').Replace('ú', 'u').Replace('í', 'i')
                .Replace((char)0xC1, 'A').Replace((char)0xE1, 'a') // á
                .Replace((char)0xC9, 'E').Replace((char)0xE9, 'e') // é
                .Replace((char)0xCD, 'I').Replace((char)0xED, 'i') // í
                .Replace((char)0xD3, 'O').Replace((char)0xF3, 'o') // ó
                .Replace((char)0xD6, 'O').Replace((char)0xF6, 'o') // ö
                .Replace((char)0xD5, 'O').Replace((char)0xF5, 'o') // ő
                .Replace((char)0xDA, 'U').Replace((char)0xFA, 'u') // ú
                .Replace((char)0xDC, 'U').Replace((char)0xFC, 'u') // ü
                .Replace((char)0xDB, 'U').Replace((char)0xFB, 'u') // ű
                .Replace((char)0x150, 'O').Replace((char)0x151, 'o') // unicode
                .Replace((char)0x170, 'U').Replace((char)0x171, 'u');
            char[] array = str.ToCharArray();
            for (int i = 0; i < array.Length; i++)
            {
                if (char.IsLetterOrDigit(array[i]) == false)
                {
                    array[i] = '_';

                }
            }
            string result = new string(array);
            while (result.IndexOf("__", StringComparison.Ordinal) > -1)
            {
                result = result.Replace("__", "_");
            }
            if (result.Length > 0 && char.IsDigit(result[0]))
            {
                return "_" + result;
            }
            return result;
            // unicode 0x150 nagy hosszú ö
            // unicode 0x151 kicsi hosszú ö
            // unicode 0x170 nagy hosszú ü
            // unicode 0x171 kicsi hosszú ü
        }

        #endregion



    }
}
