﻿using System;
using System.Diagnostics;

namespace Sda.ModelIdUpdater
{
    static class Program
    {
        public static void Main(string[] args)
        {
            if (args == null)
                throw new ArgumentNullException("args");

            Updater updater = new Updater();
            updater.LogMessageHandler += (sender, e) =>
            {
                if (e == null
                    ||
                    string.IsNullOrWhiteSpace(e.Message))
                {
                    return;
                }
                switch (e.EventType)
                {
                    case TraceEventType.Error:
                        Trace.TraceError(e.Message);
                        break;
                    case TraceEventType.Warning:
                        Trace.TraceWarning(e.Message);
                        break;
                    default:
                        Trace.TraceInformation(e.Message);
                        break;
                }
            };
            updater.UpdateIds(args.Length > 0 ? args[0] : "Model.xml");
        }
    }
}
