﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;

namespace Sda.Modeling.Runtime
{
    static class Program
    {
        readonly static TraceSource _trace = new TraceSource("Generator", SourceLevels.Error);

        public static void Main(string[] args)
        {
            if (args == null)
                throw new ArgumentNullException("args");
            List<string> files = (
                from arg in args
                where File.Exists(arg)
                select Path.GetFullPath(arg))
                .ToList();
            if (files.Count == 0)
            {
                files.Add("Model.xml");
            }
            Console.WriteLine("Started.");
            Generator generator = new Generator();
            generator.LogMessageHandler += (sender, eventArgs) => _trace.TraceEvent(eventArgs.Type, 0, eventArgs.Message);
            generator.Run(
                Path.Combine(Path.GetDirectoryName(files[0]) ?? "", "Model.deb.imf"),
                files.ToArray());
            Console.WriteLine("Finished.");
        }
    }
}
